from tkinter import *
from tkinter import messagebox
import math, time
#■初期化
root=Tk(); root.title("球をゴムひもで引っ張る動き")
canvas=Canvas(root,width=500,height=500)
canvas.pack()
canvas.focus_set()
global Pos, fact
Pos=[50, 50,100,100, 0.0,0.0] #[mouseX，mouseY，ballX, ballY, ballVX, ballVY]
fact=[0.02, 0.02]       #[Kfact, Rfact]
#■マウスを動かしたときの処理
def MouseMotion(event):
    Pos[0]=event.x
    Pos[1]=event.y
    calc(canvas, Pos, fact)
#■計算
def calc(canvas, Pos, fact):
    DX=Pos[2]-Pos[0]; DY=Pos[3]-Pos[1]
    #if math.sqrt(DX*DX+DY*DY) < 40: return
    Pos[4]= -fact[0]*DX + Pos[4]*fact[1] #X方向速度
    Pos[5]= -fact[0]*DY + Pos[5]*fact[1] #Y方向速度
    Pos[2]= Pos[2]+Pos[4]; Pos[3]= Pos[3]+Pos[5]
    canvas.delete("DT")
    canvas.create_line(Pos[0],Pos[1], Pos[2], Pos[3],fill='blue',width=2,tag="DT")
    Ball=canvas.create_oval(Pos[2]-10, Pos[3]-10, Pos[2]+10,Pos[3]+10,
                            fill='red', tag="DT")
    root.update()
#■メイン処理
canvas.bind("<Motion>", MouseMotion)
while True:
    root.update_idletasks()
    root.update()
    calc(canvas, Pos, fact)
    time.sleep(0.01)
    
 


